<?php

/**
 * @file
 * Contains \Drupal\mycustom\Controller\MycustomController.
 */

namespace Drupal\mammoth\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Component\Render\FormattableMarkup;
use Symfony\Component\HttpFoundation\JsonResponse;
use Drupal\node\Entity\Node;
use Symfony\Component\HttpFoundation\Request;

//use Drupal\anjian\Traits\OracleConnectTrait;
//use Drupal\case_sync\Helper\CaseSyncHelper;

/**
 * Returns responses for feed routes.
 */
class MammothController extends ControllerBase {
  //use OracleConnectTrait;
  /**
   * Presents the feeds feed creation form.
   *
   * @return array
   *   A form array as expected by drupal_render().
   *
   * @todo When node page gets converted, look at the implementation.
   */
  public function word2htmlPage() {
    $output = "";
$template = <<<EOT

    <div class="container">
      <input id="document" type="file" />
	  
	  <input type="button" id="copy-btn" value=":copy_html" />
      <div class="row">
        <div class="span8">
          <div id="output" class="well">
          </div>
		  
		  <textarea cols="20" rows="10" id="output-textarea" ></textarea>
        </div>
        <div class="span4">
          <h3>:messages</h3>
          <div id="messages">
          </div>
        </div>
      </div>
	</div>

EOT;


    $output = new FormattableMarkup($template, [
	  ":copy_html" => $this->t("Copy HTML"),
	  ":messages" => $this->t("Messages"),
      ]);
/*
	$output = format_string($template, array(
	  "!copy_html" => $this->t("Copy HTML"),
	  "!messages" => $this->t("Messages"),
	));
	*/

    $build = [
      '#markup' => $output,
	  '#allowed_tags' => ['div','input','h3', 'textarea'],
    ];
	
	$build['#attached']['library'][] = 'mammoth/mammoth';
    $build['#attached']['drupalSettings']['mammoth'] = [
      'basePath' => base_path(),
    ];		
    return $build;
  }
  
  public function uploadImg(Request $request){
    $ret = [];
    //$errmsg = 'successful';
    //get data
    //$content = \Drupal::request()->getContent();
	//\Drupal::logger('mammoth')->notice("123:" . var_export($content, true));
	$received = file_get_contents("php://input"); // Use inputstream module.
    $content = json_decode($received, TRUE);
	//\Drupal::logger('mammoth')->notice("received:" . var_export($received, true));
	//\Drupal::logger('mammoth')->notice("abc:" . var_export($content, true));
	$img_type = isset($content["imgType"]) ? $content["imgType"] : "";
	$img_buffer = isset($content["imgBuffer"]) ? $content["imgBuffer"] : "";
	\Drupal::logger('mammoth')->notice(var_export($img_type, true));
	
	if($img_type === "" || $img_buffer === ""){
	  return new JsonResponse($ret, 201);	
	}
	
	//prepare file name, dir
	$img_type_arr = explode("/", $img_type);
	
	$ext = isset($img_type_arr[1]) ? $img_type_arr[1] : "";
	if($ext === ""){
	  return new JsonResponse($ret, 201);	
	}
	
    $decode = base64_decode($img_buffer);
	//date('Y-m-d H:i:s', time());
    $file_dir = 'public://mammoth/' . date('Y') . '/' .  date('m')  . '/' . date('d') ;
    //$return = file_prepare_directory($file_dir);
    $return = \Drupal::service('file_system')->prepareDirectory($file_dir);
    if (empty($return)) {
	  //drupal_mkdir($file_dir, 0777, TRUE);
	  \Drupal::service('file_system')->mkdir($file_dir, 0777, TRUE);
    }
	
    $name = md5($img_buffer);

    $uri = $file_dir  . "/" . $name . '.' . $ext;
	
	//save file	
	$file = NULL;
	
	if(function_exists("file_save_data")){	 
	  $file = file_save_data($decode, $uri);	
    }else{
	  $file = \Drupal::service('file.repository')->writeData($decode, $uri);
	}
	
	if(empty($file)){
	  return new JsonResponse($ret, 201);	
	}
	
	$file_uri = $file->getFileUri();
	$file_url = "";
	if(function_exists("file_create_url")){	 
	  $file_url = file_create_url($file_uri);	
    }else{
	  $file_url = \Drupal::service('file_url_generator')->generateString($file_uri);
	}
	
    $uuid = $file->uuid();	
    
    $ret = [
	  "imgUrl" => $file_url,
      "uuid" => $uuid,	  
	];
	
	\Drupal::logger('mammoth')->notice(var_export($ret, true));

    return new JsonResponse($ret, 201);
  }
 
}
